<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	GNU/GPL, see LICENSE.php
* @package	Payplans
* @subpackage	Plan Modifier App
* @contact	payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Planmodifier Plugin
 */
class plgPayplansPlanmodifier extends XiPlugin
{
	public function onPayplansSystemStart()
	{
		$appPath = dirname(__FILE__).DS.'planmodifier'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);

		return true;
	}
	
	public function onPayplansViewBeforeRender(XiView $view, $task)
	{
		if(!($view instanceof PayplanssiteViewPlan) || $task != 'login'){
			return true;
		}
		
		$plan = $view->get('plan');
		
		$session 	= XiFactory::getSession();
		$modify_by 	= $session->get('modify_plan_by', array());
		$planid 	= $plan->getId();
		if(!isset($modify_by[$planid])){
			// do nothing
			return true;
		}
		
		$plan->setPrice($modify_by[$planid]['price']);
		$plan->setExpiration($modify_by[$planid]['time']);
		$plan->set('title', $modify_by[$planid]['title']);
		
		$view->assign('plan', $plan);
		return true;		
	}
	
	public function onPayplansSubscriptionBeforeSave($prev, $new)
	{
		// do nothing if prev instance is not null
		if($prev != null){
			return true;
		}
		
		$session 	= XiFactory::getSession();
		$modify_by 	= $session->get('modify_plan_by', array());
		$plans		= $new->getPlans();
		$planid 	= array_pop($plans);
		
		if(!isset($modify_by[$planid])){
			// do nothing
			return true;
		}
		
		$new->setPrice($modify_by[$planid]['price']);
		$new->setExpiration($modify_by[$planid]['time']);
		$new->setParam('title', $modify_by[$planid]['title']);
		
		return true;
	}
	
	public function onAfterRoute()
	{
		$option = PayplansFactory::getApplication()->input->get('option', false);
		$view 	= PayplansFactory::getApplication()->input->get('view', false);
		$task 	= PayplansFactory::getApplication()->input->get('task', false);
		$planid = PayplansFactory::getApplication()->input->get('plan_id', false);
		
		if($option != 'com_payplans' || $view != 'plan' || $task != 'subscribe' || !$planid){
			return true;
		}
		
		$modifier_value = PayplansFactory::getApplication()->input->get('selected', false);
		$price_time 	= explode('_', $modifier_value);
		$price 			= $price_time[0];
		$time 			= isset($price_time[1]) ? $price_time[1] : '';
		$plan 			= PayplansPlan::getInstance($planid);
		
		$args 		= array($price, $time, $plan);
		PayplansHelperEvent::trigger('onPayplansPlanModificationRequestApply', $args, '', $plan);
		
		return true;
	}
	
}
