<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();


class JFormFieldPlanmodifier extends XiField
{
	public $type = 'planmodifier'; 
	
	function getInput()
	{
		$values = unserialize($this->value);
		$html = '<div id="pp_planmodifier">';
		
		$count = ( isset($values['price']) && count($values['price']) > 0 ) ? count($values['price']) : 1; 
		for($i=0; $i < $count ; $i++)
		{
			$priceHtml = PayplansHtml::_('price.edit', $this->name.'[price][]',$this->name.'_price_'.$i, $values['price'][$i]);
			$titleHtml = '<input type="text" name="'.$this->name.'[title][]" id="'.$this->name.'_title_'.$i.'" value="'.$values['title'][$i].'" />';
			$timerHtml = PayplansHtml::_('timer.edit', $this->name.'[time][]', $values['time'][$i], $this->name.'_time_'.$i);
			$html .= '<div class="row_'.$i.'">'.$titleHtml.$priceHtml;
			$html .= '<a href="#" class="pp_planmodifier_remove" counter="'.$i.'"><i class="pp-icon-remove"></i></a><div class="clr"></div>';
			$html .= $timerHtml;
			
			$html .= '<br /></div>'; 
		}
		
		self::_getFilterScript( $this->name, $i);
	
		return $html.'</div><a id="pp_plansmodifer_add" href="#"><i class="pp-icon-plus"></i></a>';
	}
	
	
	protected static function _getFilterScript( $name, $count)
	{
		ob_start();
		?>	
		(function($){
			$(document).ready(function(){
				// Set the starting id number
				var DefaultNumber = <?php echo $count;?>;
				var timer_class = '<?php echo XiHelperUtils::jsCompatibleId($name.'_time','_'); ?>';
				var microsubscription = false;
				<?php if(XiFactory::getConfig()->microsubscription){?>
							microsubscription = true;
				<?php }?>
				
				$('#pp_plansmodifer_add').click(function(){
					$( "#pp_planmodifier" ).append(payplans.element.planmodifier.getElementHtml(timer_class, DefaultNumber));
					
					payplans.element.timer.setup(timer_class+ '_' + DefaultNumber, '000000000000');
					
					DefaultNumber++;
					return false;
				});
				
				$('.pp_planmodifier_remove').live('click', function(){
					$('.row_'+ $(this).attr('counter')).remove();
					return false;
				});
				
				
				// if elements not defined already
				if(typeof(payplans.element.planmodifier)=='undefined'){
					payplans.element.planmodifier = {};
				}
		
				payplans.element.planmodifier = {
					getElementHtml : function(class_name, counter){
						var html = '';
						var timer_class = 'timer-warp-' + class_name + '_' + counter;
						var select_class = class_name + '_' + counter;
						html += '<div class="row_'+ counter +'">';
						html += '<input type="text" value="" id="Payplans_form[app_params][time_price]_title_'+counter+'" name="Payplans_form[app_params][time_price][title][]" class="">';
						html += '<input type="text" value="0.00" id="Payplans_form[app_params][time_price]_price_'+counter+'" name="Payplans_form[app_params][time_price][price][]" class="">';
						html +=	'<a counter="'+counter+'" class="pp_planmodifier_remove" href="#">';
						html += '<i class="pp-icon-remove"></i>';
						html += '</a>';
						html += '<div class="clr"></div>';
						html += '<div id="' + timer_class +'">';
						html += '<div class="readable pp-mouse-pointer"><span class="pp-icon-edit">&nbsp;</span><span class="pp-content"></span></div>';
						html += '<div class="editable" style="display: none;">';
						html += '<span><?php echo XiText::_('COM_PAYPLANS_TIMER_YEARS');?></span>';
						html += '<select id="' + select_class +'_year" name="' + select_class +'_year" class="' + select_class +'">';
						for(index=0; index <= 10 ; index++){
							html += '<option value="'+ index +'">'+index+'</option>';
						}
						html += '</select>';
						html += '<span><?php echo XiText::_('COM_PAYPLANS_TIMER_MONTHS');?></span>';
						html += '<select id="' + select_class +'_month" name="' + select_class +'_month" class="' + select_class +'">';
						for(index=0; index <= 11 ; index++){
							html += '<option value="'+ index +'">'+index+'</option>';
						}
						html += '</select>';
						html += '<span><?php echo XiText::_('COM_PAYPLANS_TIMER_DAYS');?></span>';
						html += '<select id="' + select_class +'_day" name="' + select_class +'_day" class="' + select_class +'">';
						for(index=0; index <= 30 ; index++){
							html += '<option value="'+ index +'">'+index+'</option>';
						}
						html += '</select>';
						if(microsubscription == true){
							html += '<span><?php echo XiText::_('COM_PAYPLANS_TIMER_HOURS');?></span>';
							html += '<select id="' + select_class +'_hour" name="' + select_class +'_hour" class="' + select_class +'">';
							for(index=0; index <= 23 ; index++){
								html += '<option value="'+ index +'">'+index+'</option>';
							}
							html += '</select>';
							html += '<span><?php echo XiText::_('COM_PAYPLANS_TIMER_MINUTES');?></span>';
							html += '<select id="' + select_class +'_minute" name="' + select_class +'_minute" class="' + select_class +'">';
							for(index=0; index <= 59 ; index++){
								html += '<option value="'+ index +'">'+index+'</option>';
							}
							html += '</select>';
						}
						html += '<input type="hidden" value="000000000000" name="Payplans_form[app_params][time_price][time][]" id="' + select_class +'">';
						html += '</div>';
						html += '</div>';
						html += '<br>';
						html += '</div>';
									
						return html;
					}
				}
			});				
		})(payplans.jQuery);
		<?php 
		$content = ob_get_contents();
		ob_end_clean();
		
		XiFactory::getDocument()->addScriptDeclaration($content);
	}

	
}
