<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplansAppPlanmodifier extends PayplansApp
{
	protected $_location	= __FILE__;

	public function isApplicable($refObject = null, $eventName='')
	{
		if($eventName == 'onPayplansViewBeforeRender'){
			return true;
		}
		
		return parent::isApplicable($refObject, $eventName);
	}
	
	public function collectAppParams(array $data)
	{
		$data['app_params']['time_price'] = isset($data['app_params']['time_price']) ? serialize($data['app_params']['time_price']) : serialize(array()); 
		return PayplansHelperParam::collectParams($data,'app_params');
	}
	
	public function onPayplansViewBeforeRender(XiView $view, $task)
	{   
		if(!($view instanceof PayplanssiteViewPlan) || ($task != '' && $task != 'subscribe')){
			return true;	
		}
		
		$plans = $view->get('plans');
		$time_price = unserialize($this->getAppParam('time_price'));
		
		if($this->getParam('applyAll',false) == false){
			$appPlans = $this->getPlans();

			$cloneplans = $plans;
			foreach($cloneplans as $planid => $plan){
				if(!in_array($planid, $appPlans)){
					unset($plans[$planid]);
				}
			}
		}
		
		$this->assign('time_price', $time_price);
		$ret = array();
		foreach($plans as $id => $plan){
			$this->assign('plan', $plan);
			$ret['plan-block-bottom_'.$id] = $this->_render('planmodifier');
		}
		
		PayplansHtml::script(dirname(__FILE__).DS.'tmpl'.DS.'planmodifier.js');			
		return $ret;
	}

	public function onPayplansPlanModificationRequestApply($price, $time, $plan)
	{
			$params = unserialize($this->getAppParam('time_price'));
			$found  = false;
			
			if($price == $plan->getPrice() && $time == $plan->getRawExpiration()){
				$found = true;
			}			
			
			$title = $plan->getTitle();
			if($found === false){
				for($i=0 ; $i < count($params['price']) ; $i++){
					if($price == $params['price'][$i] && $params['time'][$i] == $time ){
						$title = (isset($params['title']) && !empty($params['title'][$i]) ) ? $params['title'][$i] : $title ;
						$found = true;
						break;
					}				
				}
			}
						
			if($found === true){
				$session 	= XiFactory::getSession();
				if($session->get('modify_plan_by', false)){
					$modify_plans = $session->get('modify_plan_by');
				}
				
				$modify_plans[$plan->getId()] = array(	'plan_id' => $plan->getId(),
												'price'   => $price,
												'time'	  => $time,
												'title'   => $title);
				
				$session->set('modify_plan_by', $modify_plans);
			}
			
			return $found;
	}
}


